{***************************************************************************}
{ TMS GuiMotions Demo                                                       }
{ for Delphi & C++Builder                                                   }
{                                                                           }
{ written by TMS Software                                                   }
{            copyright  2008                                               }
{            Email : info@tmssoftware.com                                   }
{            Web : http://www.tmssoftware.com                               }
{                                                                           }
{ The source code is given as is. The author is not responsible             }
{ for any possible damage done due to the use of this code.                 }
{ The component can be freely used in any application. The complete         }
{ source code remains property of the author and may not be distributed,    }
{ published, given or sold in any form as such. No parts of the source      }
{ code can be included in any other component or application without        }
{ written authorization of the author.                                      }
{***************************************************************************}

{
	- Chart must be installed to run demo (http://www.tmssoftware.com/site/advchart.asp)
	- d3dx9_33.dll must be present in the \Windows\System32 folder
}

unit GUImotionsC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GUIMotions, StdCtrls, AdvChartView, AdvChartViewGDIP, Math,
  AdvChartPaneEditorGDIP, ComCtrls, AdvChartUtil, GUIMotions3D,
  AdvChart, DateUtils, ExtCtrls, AdvChartGDIP;

type
  TForm42 = class(TForm)
    Guimotions1: TGUIMotions;
    AdvChartPanesEditorDialogGDIP1: TAdvChartPanesEditorDialogGDIP;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Guimotions1ImageChanged(Sender: TObject; PreviousImage,
      CurrentImage: Integer; device: IDirect3DDevice9);
    procedure Guimotions1ImageCustomDraw(Sender: TObject; Image: Integer;
      Picture: TBitmap);
    procedure Guimotions1ImageZoomed(Sender: TObject; Image: Integer;
      ImageRectangle: TRect);
    procedure Guimotions1ImageUnZoom(Sender: TObject; Image: Integer;
      ImageRectangle: TRect);
  private
    { Private declarations }
  protected
    procedure MouseUpChart(Sender: Tobject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  public
    { Public declarations }
  end;

var
  Form42: TForm42;

implementation

{$R *.dfm}

procedure TForm42.FormCreate(Sender: TObject);
var
  I, K, J, cc: Integer;
  c: TAdvGDIPChartView;
  colors: array[0..27] of TColor;
  piecolors: array[0..6] of TColor;
  types: array[0..4] of integer;
  value: integer;
  col1: TColor;
  col2: TColor;
begin

  Self.Width := 1280;
  self.Height := 1024;

  for I := 0 to 6 do
    piecolors[I] := RGB(Random(255), Random(255), Random(255));

  colors[0] := $5ACDEF;
  colors[1] := $4DACC9;
  colors[2] := $3E8CA3;
  colors[3] := $F0AF5B;
  colors[4] := $C97F4D;
  colors[5] := $A3663E;
  colors[6] := $2D8DCE;
  colors[7] := $2574A8;
  colors[8] := $1D5982;

  colors[9] := $CFA42D;
  colors[10] := $A86F25;
  colors[11] := $82561D;
  colors[12] := $2D8D8B;
  colors[13] := $39B3B0;
  colors[14] := $45D9D6;
  colors[15] := $2D8C4B;
  colors[16] := $39B360;
  colors[17] := $45D974;

  colors[18] := $32A800;
  colors[19] := $3ECF00;
  colors[20] := $49F500;
  colors[21] := $A3A800;
  colors[22] := $C8CF00;
  colors[23] := $EDF500;
  colors[24] := $FF0032;
  colors[25] := $B30024;
  colors[26] := $B35647;

  types[0] := 1;
  types[1] := 2;
  types[2] := 3;
  types[3] := 20;    


  Guimotions1.PictureWidthZoomed := Guimotions1.Width - 50;
  Guimotions1.PictureHeightZoomed := Guimotions1.Height - 50;

  for I := 1 to 12 do
  begin
    with GUIMotions1.Images.Add do
    begin
      c := TAdvGDIPChartview.Create(GUIMotions1);
      c.Visible := false;
      c.Panes.Add;
      c.Color := clwhite;
      with c.Panes[0] do
      begin
        Randomize;
        YAxis.Color := Colors[random(27)];
        XAxis.Color := YAxis.Color;
        YAxis.Size := 40;
        XAxis.Size := 40;
        Xaxis.Position := xBoth;
        YAxis.Position := yBoth;
        Range.RangeFrom := 0;
        Range.RangeTo := 20;
        AxisMode := amXAxisFullWidth;

        if not Odd(I) then
          cc := 2
        else
          cc := 0;

        for K := 0 to cc do
        begin
          Series.Add;
          with Series[K] do
          begin
            Randomize;

            if cc = 0 then
              ChartType := ctPie
            else
              ChartType := TChartType(types[Random(3)]);

            AutoRange := arEnabled;
            Randomize;
            Color := Colors[random(27)];
            Randomize;
            ColorTo := Colors[random(27)];
            Randomize;
            GradientType := TChartGradientType(Random(7));
            if GradientType = gtAngle then
              GradientType := gtSolid;
            Randomize;
            HatchStyle := THatchStyle(1 + Random(10));
            Randomize;
            Opacity := RandomRange(100, 255);
            Randomize;
            OpacityTo := RandomRange(100, 255);
            Randomize;
            Marker.MarkerColor := Colors[random(27)];
            Randomize;
            Marker.MarkerColorTo := Colors[random(27)];
            Randomize;
            Marker.MarkerType := TChartMarkerType(Random(5));
            Randomize;
            LineColor := Colors[random(27)];
            LineWidth := 2;
            Randomize;
            PenStyle := TPenstyle(Random(3));
            AutoRange := arCommonZeroBased;
            YAxis.Position := yNone;
            XAxis.Position := xNone;
            Randomize;
            XAxis.MajorFont.Size := RandomRange(10, 16);
            XAxis.Visible := false;
            ValueFormat := '%.0f';
            Pie.Size := 500;
            Randomize;
            Pie.LegendGradientType := TChartGradientType(Random(7));
            if Pie.LegendGradientType = gtAngle then
              Pie.LegendGradientType := gtSolid;

            pie.ShowValues := true;
            Randomize;
            Pie.LegendHatchStyle := THatchStyle(1 + Random(10));
            Randomize;
            Pie.LegendColor := Colors[random(27)];
            Randomize;
            Pie.LegendColorTo := Colors[random(27)];
            Randomize;
            Pie.LegendFont.Size := RandomRange(10, 16);
            Randomize;
            Pie.LegendFont.Color := Colors[random(27)];
            Randomize;
            Pie.LegendOpacity := RandomRange(100, 255);
            Randomize;
            Pie.LegendOpacityTo := RandomRange(100, 255);
            Randomize;
            Pie.LegendBorderColor := Colors[random(27)];
            Randomize;
            Pie.LegendBorderWidth := RandomRange(1, 4);
            Randomize;
            Legend.Color := Colors[Random(27)];
            Randomize;
            Legend.GradientType := TChartGradientType(Random(7));
            if Legend.GradientType = gtAngle then
              Legend.GradientType := gtSolid;

            Legend.Visible := false;

            if ChartType = ctPie then
              cc := 10
            else
              cc := 20;

            for J := 0 to cc do
            begin
              Randomize;
              case ChartType of
                ctBar, ctArea, ctLine: AddSinglePoint(RandomRange(10, 50));
                ctPie:
                begin
                  Randomize;
                  value := RandomRange(10, 50);
                  col1 := colors[Random(27)];
                  Randomize;
                  col2 := colors[Random(27)];
                  AddPiePoints(value,'Random value : ' + inttostr(value), col1, col2);
                end;
              end;
            end;
          end;
        end;
      end;

      Randomize;
      c.Panes[0].Background.Color := Colors[random(27)];

      c.Panes[0].Series[0].YAxis.Position := yLeft;
      c.Panes[0].Series[0].XAxis.Position := xBottom;
      c.Panes[0].Series[0].XAxis.Visible := not (c.Panes[0].Series[0].charttype = ctpie);
      c.Panes[0].Series[0].yAxis.Visible := not (c.Panes[0].Series[0].charttype = ctpie);
      c.Panes[0].Background.GradientType := gtSolid;
      c.Parent := GUIMotions1;
      c.OnMouseUp := Self.MouseUpChart;

      Control := c;
      Caption := LongMonthNames[i];
    end;
  end;
end;

procedure TForm42.Guimotions1ImageChanged(Sender: TObject; PreviousImage,
  CurrentImage: Integer; device: IDirect3DDevice9);
var
  i: integer;
begin
  for I := 0 to GUIMotions1.Images.Count - 1 do
    with GUIMotions1.Images[I] do
      Control.Visible := false;
end;

procedure TForm42.Guimotions1ImageCustomDraw(Sender: TObject; Image: Integer;
  Picture: TBitmap);
var
  c: TAdvGDIPChartView;
begin
  c := TAdvGDIPChartView(GUIMotions1.Images[Image].Control);

  c.Width := Guimotions1.PictureWidthZoomed;
  c.Height := Guimotions1.PictureHeightZoomed;

  picture.Width := Guimotions1.PictureWidthZoomed;
  picture.Height := Guimotions1.PictureHeightZoomed;

  c.PaintTo(Picture.Canvas, 0, 0);

  Picture.Canvas.Pen.Color := clBlack;
  Picture.Canvas.Pen.Width := 2;
  Picture.Canvas.Brush.Style := bsClear;
  Picture.Canvas.Rectangle(1,1,Picture.Width,Picture.Height);

end;

procedure TForm42.Guimotions1ImageUnZoom(Sender: TObject; Image: Integer;
  ImageRectangle: TRect);
var
  i: integer;
begin
  for I := 0 to GUIMotions1.Images.Count - 1 do
    with GUIMotions1.Images[I] do
      Control.Visible := false;
end;

procedure TForm42.Guimotions1ImageZoomed(Sender: TObject; Image: Integer;
  ImageRectangle: TRect);
var
  r: TRect;
begin
  AdvChartPanesEditorDialogGDIP1.ChartView := TAdvGDIPChartview(GUIMotions1.Images[Image].Control);
  r := ImageRectangle;
  TAdvGDIPChartview(GUIMotions1.Images[Image].Control).SetBounds(r.Left, r.Top, r.Right - r.Left, r.Bottom - r.Top);
  TAdvGDIPChartview(GUIMotions1.Images[Image].Control).visible := true;
end;

procedure TForm42.MouseUpChart(Sender: Tobject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  AdvChartPanesEditorDialogGDIP1.Execute;
  GUIMotions1.Images[GUIMotions1.GetCurrentSelectedImage].Update;
end;

end.
