{***************************************************************************}
{ TMS GuiMotions Demo                                                       }
{ for Delphi & C++Builder                                                   }
{                                                                           }
{ written by TMS Software                                                   }
{            copyright  2008                                               }
{            Email : info@tmssoftware.com                                   }
{            Web : http://www.tmssoftware.com                               }
{                                                                           }
{ The source code is given as is. The author is not responsible             }
{ for any possible damage done due to the use of this code.                 }
{ The component can be freely used in any application. The complete         }
{ source code remains property of the author and may not be distributed,    }
{ published, given or sold in any form as such. No parts of the source      }
{ code can be included in any other component or application without        }
{ written authorization of the author.                                      }
{***************************************************************************}

//	- d3dx9_33.dll must be present in the \Windows\System32 folder

unit guiDemo;

//filectrl warning
{$WARN UNIT_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Math, ComCtrls,
  StdCtrls, ExtCtrls, FileCtrl, GUIMotions, GUIMotions3D, ShellAPI;

type
  TMode = (AnimationDEMO, ChartDEMO);
  TForm43 = class(TForm)
    GUIMotions1: TGUIMotions;
    Label4: TLabel;
    ProgressBar1: TProgressBar;
    Panel2: TPanel;
    Button4: TButton;
    ComboBox6: TComboBox;
    colordialog1: TColorDialog;
    Panel1: TPanel;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    CheckBox1: TCheckBox;
    Button1: TButton;
    CheckBox2: TCheckBox;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    ComboBox4: TComboBox;
    ComboBox3: TComboBox;
    ComboBox2: TComboBox;
    ComboBox5: TComboBox;
    Label13: TLabel;
    CheckBox3: TCheckBox;
    Label14: TLabel;
    CheckBox4: TCheckBox;
    Label12: TLabel;
    ComboBox7: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure GUIMotions1ImageChanged(Sender: TObject; PreviousImage,
      CurrentImage: Integer; device: IDirect3DDevice9);
    procedure GUIMotions1ImageCustomAlternateDraw(Sender: TObject;
      Image: Integer; Picture: TBitmap);
    procedure GUIMotions1ImageLoaded(Sender: TObject; Image: Integer;
      alternate: Boolean);
    procedure ComboBox7Change(Sender: TObject);
    procedure SetZoom;
  private
    procedure SelectImages;
    { Private declarations }
  public
    { Public declarations }
  end;


type
  TZoomMode = (zmNone, zmNormal, zmFullscreen);
var
  Form43: TForm43;
  dir: String;
  mode: TZoomMode;

implementation

{$R *.dfm}

procedure TForm43.Button1Click(Sender: TObject);
begin
  ColorDialog1.Color := GUIMotions1.GlowColor;
  if ColorDialog1.Execute then
  begin
    GUIMotions1.GlowColor := ColorDialog1.Color;
  end;
  GUIMotions1.EnableRendering(true);
  GUIMotions1.Render;
end;

procedure TForm43.Button2Click(Sender: TObject);
begin
  ColorDialog1.Color := GUIMotions1.MirrorColor;
  if ColorDialog1.Execute then
    GUIMotions1.MirrorColor := ColorDialog1.Color;

  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetLoadingImagesCount;
  end;
end;

procedure TForm43.Button3Click(Sender: TObject);
begin
  ColorDialog1.Color := GUIMotions1.BackColor;
  if ColorDialog1.Execute then
  begin
    GUIMotions1.BackColor := ColorDialog1.Color;
  end;
  GUIMotions1.EnableRendering(true);
  GUIMotions1.Render;
end;

procedure TForm43.Button4Click(Sender: TObject);
begin
  SelectImages;
end;

procedure TForm43.CheckBox1Click(Sender: TObject);
begin
  GUIMotions1.Glow := CheckBox1.Checked;
  GUIMotions1.EnableRendering(true);
  GUIMotions1.Render;
end;

procedure TForm43.CheckBox2Click(Sender: TObject);
begin
  GUIMotions1.Mirror := CheckBox2.Checked;
  GUIMotions1.EnableRendering(true);
  GUIMotions1.Render;
end;

procedure TForm43.CheckBox3Click(Sender: TObject);
begin
  GUIMotions1.ScrollBar.Visible := CheckBox3.Checked;
end;

procedure TForm43.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked then
    GUIMotions1.ImageMode := imAspectRatio
  else
    GUIMotions1.ImageMode := imNormal;
end;

procedure TForm43.ComboBox1Change(Sender: TObject);
begin
  GUIMotions1.AnimationMode := TGUIMotionsAnimationMode(ComboBox1.ItemIndex);
  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetRenderingCount;
  end;
end;

procedure TForm43.ComboBox2Change(Sender: TObject);
begin
  GUIMotions1.ImageLoading := TGUIMotionsImageLoading(ComboBox2.ItemIndex);
  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetRenderingCount;
  end; 
end;

procedure TForm43.ComboBox3Change(Sender: TObject);
begin
  GUIMotions1.ImageQuality := TGUIMotionsImageQuality(ComboBox3.ItemIndex);
  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetRenderingCount;
  end; 
end;

procedure TForm43.ComboBox4Change(Sender: TObject);
begin
  case ComboBox4.ItemIndex of
    0:
    begin
      GUIMotions1.MirrorBottomAlpha := 0;
      GUIMotions1.MirrorTopAlpha := 50;
    end;
    1:
    begin
      GUIMotions1.MirrorBottomAlpha := 50;
      GUIMotions1.MirrorTopAlpha := 150;
    end;
    2:
    begin
      GUIMotions1.MirrorBottomAlpha := 200;
      GUIMotions1.MirrorTopAlpha := 255;
    end;
  end;

  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetLoadingImagesCount;
  end;  
end;

procedure TForm43.ComboBox5Change(Sender: TObject);
begin                     
  GUIMotions1.AnimationFactor := 10 * (ComboBox5.ItemIndex + 1);
end;

procedure TForm43.ComboBox7Change(Sender: TObject);
begin
  case ComboBox7.ItemIndex of
  0: mode := zmNone;
  1: mode := zmNormal;
  2: mode := zmFullscreen;
  end;

  SetZoom;
end;

procedure TForm43.FormCreate(Sender: TObject);
begin
  Guimotions1.Hint := 'To change image click on an image or drag mouse and release' + #13
                    + 'Right click to see the alternate image';
  ComboBox1.ItemIndex := Integer(GUIMotions1.AnimationMode);
  ComboBox2.ItemIndex := Integer(GUIMotions1.ImageLoading);
  ComboBox3.ItemIndex := Integer(GUIMotions1.ImageQuality);
  CheckBox1.Checked := GUIMotions1.Glow;
  CheckBox2.Checked := GUIMotions1.Mirror;
  CheckBox3.Checked := GUIMotions1.ScrollBar.Visible;
  case GUIMotions1.ImageMode of
    imNormal: CheckBox4.Checked := false;
    imAspectRatio: CheckBox4.Checked := true;
  end;

  GUIMotions1.AddThreadedImageLocationsFromFolder(ExtractFilePath(Application.ExeName) + '\Images_Resized\*.jpg');

  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetLoadingImagesCount;
  end;

  ComboBox7.ItemIndex := 1;
  mode := zmNormal;
  SetZoom;
end;

procedure TForm43.SetZoom;
begin
  case mode of
    zmNone:
    begin
      GUIMotions1.PictureWidthZoomed := GUIMotions1.PictureWidth;
      GUIMotions1.PictureHeightZoomed := GUIMotions1.Images[GUIMotions1.GetCurrentSelectedImage].GetPictureAspectHeight;
    end;
    zmNormal:
    begin
      GUIMotions1.PictureWidthZoomed := GUIMotions1.Width div 3 * 2;
      GUIMotions1.PictureHeightZoomed := GUIMotions1.Height div 3 * 2;
    end;
    zmFullscreen:
    begin
      GUIMotions1.PictureWidthZoomed := GUIMotions1.Width;
      GUIMotions1.PictureHeightZoomed := GUIMotions1.Height;
    end;
  end;
end;

procedure TForm43.GUIMotions1ImageChanged(Sender: TObject; PreviousImage,
  CurrentImage: Integer; device: IDirect3DDevice9);
begin
  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetLoadingImagesCount;
  end;
end;

procedure TForm43.GUIMotions1ImageCustomAlternateDraw(Sender: TObject;
  Image: Integer; Picture: TBitmap);
type
  TFileInfo = record
    Icon : hIcon;
    Image : Integer;
    DisplayName : String;
    TypeName : String;
    Size : Integer;
    SizeDescription : String;
    DateTime : TDateTime;
    AttrArchive : Boolean;
    AttrReadOnly : Boolean;
    AttrSystem : Boolean;
    AttrHidden : Boolean;
    AttrVolume : Boolean;
    AttrDirectory : Boolean;
  end;

  function scGetSizeDescription(const IntSize : Int64) : String;
  begin
    if IntSize < 1024 then
      Result := IntToStr(IntSize)+' bytes'
    else
    begin
      if IntSize < (1024 * 1024) then
        Result := FormatFloat('####0.##',IntSize / 1024)+' Kb'
      else
        if IntSize < (1024 * 1024 * 1024) then
          Result := FormatFloat('####0.##',IntSize / 1024 / 1024)+' Mb'
        else
          Result := FormatFloat('####0.##',IntSize / 1024 / 1024 / 1024)+' Gb';
    end;
  end;

  procedure scGetFileInfo(StrPath : String; var Info : TFileInfo);
  var
    SHFileInfo : TSHFileInfo;
    SearchRec : TSearchRec;
  begin
    if Trim(StrPath) = '' then
      Exit;

    ShGetFileInfo(PChar(StrPath), 0, SHFileInfo, SizeOf (TSHFileInfo),
      SHGFI_TYPENAME or SHGFI_DISPLAYNAME or SHGFI_SYSICONINDEX or SHGFI_ICON);

    with Info do
    begin
      Icon  := SHFileInfo.hIcon;
      Image := SHFileInfo.iIcon;
      DisplayName := SHFileInfo.szDisplayName;
      TypeName := SHFileInfo.szTypeName;
    end;

    FindFirst(StrPath, 0, SearchRec);
    with Info do
    begin
      try
        DateTime := FileDateToDateTime(SearchRec.Time);
      except
        DateTime := Now();
      end;

      AttrReadOnly := ((SearchRec.Attr and faReadOnly) > 0);
      AttrSystem := ((SearchRec.Attr and faSysFile) > 0);
      AttrHidden := ((SearchRec.Attr and faHidden) > 0);
      AttrArchive := ((SearchRec.Attr and faArchive) > 0);
      AttrVolume := ((SearchRec.Attr and faVolumeID) > 0);
      AttrDirectory := ((SearchRec.Attr and faDirectory) > 0);

      Size := SearchRec.Size;

      SizeDescription := scGetSizeDescription(Size);
    end;
  end;

var
  a, b, c, d, e: String;
  stah, stbh, stch, stdh, steh: integer;
  info: TFileInfo;
  ic: TIcon;
begin
   scGetFileInfo(GUIMotions1.Images[Image].FullCaption, info);
   picture.Width := GUIMotions1.PictureWidth * 2;
   picture.Height := GUIMotions1.Images[Image].GetPictureAspectHeight * 2;
   picture.Canvas.Font.Name := 'Tahoma';
   picture.Canvas.Font.Size := 15;
   //Image Number
   a := 'Image ' + inttostr(Image + 1);
   stah := picture.Canvas.TextHeight(a);
   //Image Name
   b := ExtractFileName(GUIMotions1.Images[Image].Caption);
   stbh := picture.Canvas.TextHeight(b);
   //Image res
   c := inttostr(Guimotions1.Images[Image].GetOriginalPictureWidth) + ' x ' + inttostr(Guimotions1.Images[Image].GetOriginalPictureHeight);
   stch := picture.Canvas.TextHeight(c);
   //Image File Date
   d := FormatDateTime('dd/mm/yy',info.DateTime);
   stdh := picture.Canvas.TextHeight(d);
   //Image File Size
   e := scGetSizeDescription(info.Size);
   steh := picture.Canvas.TextHeight(e);

   picture.Canvas.Font.Style := Font.Style + [fsBold];
   picture.Canvas.TextOut(20, stah ,a);
   stah := stah + 20;   
   picture.Canvas.Font.Style := Font.Style - [fsBold];
   picture.Canvas.TextOut(20, stah + stbh, 'Image Name : ' + b);
   picture.Canvas.TextOut(20, stah + stbh + stch, 'Image Resolution : ' + c);
   picture.Canvas.TextOut(20, stah + stbh + stch + stdh, 'Image File Date : ' + d);
   picture.Canvas.TextOut(20, stah + stbh + stch + stdh + steh, 'Image File Size : ' + e);

   //ICON
  ic := TIcon.Create;
  try
   ic.Handle := info.Icon;
   picture.Canvas.Draw(picture.Width - ic.Width - 5, picture.Height - ic.Height - 5, ic);
  finally
   ic.free;
  end;
end;

procedure TForm43.GUIMotions1ImageLoaded(Sender: TObject; Image: Integer;
  alternate: Boolean);
begin
  ProgressBar1.Position := ProgressBar1.Position + 1;
end;

procedure TForm43.SelectImages;
begin
  if SelectDirectory('Select a directory', '', dir) then
  begin
    GUIMotions1.Images.Clear;
    GUIMotions1.AddThreadedImageLocationsFromFolder(dir + '\' + ComboBox6.Items[ComboBox6.ItemIndex]);
    GUIMotions1.Reset;
  end;

  if GUIMotions1.Images.Count > 0 then
  begin
    ProgressBar1.Position := 0;
    ProgressBar1.Max := GUIMotions1.GetRenderingCount;
  end;  
end;

end.
